﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using DG.Tweening;

[RequireComponent(typeof(Rigidbody))]
public class PlayerScript : MonoBehaviour {
	private Rigidbody _Rigidbody;
	private Rigidbody m_Rigidbody{
		get{
			return _Rigidbody ?? (_Rigidbody = GetComponent<Rigidbody>());
		}
	}


	private WaveScript m_WorldWave;
	private WaveScript m_UserWave;
	public ParticleSystem m_particle;

	public GameObject m_Finger;

	void Start(){
		m_WorldWave = GameObject.Find ("Wave0").GetComponent<WaveScript>();
		m_UserWave = GameObject.Find ("Wave1").GetComponent<WaveScript>();
	}

	void FixedUpdate(){
		m_Rigidbody.velocity = m_WorldWave.Velocity + m_UserWave.Velocity;
//		m_Rigidbody.AddForce(m_WorldWave.Velocity + m_UserWave.Velocity);
	}

	void OnEnable(){
		if (GestureRecognize.IsValid ()) {
			GestureRecognize.Instance.OnFlick += OnFlick;
		}
	}
	void OnDisable(){
		if (GestureRecognize.IsValid ()) {
			GestureRecognize.Instance.OnFlick -= OnFlick;
		}
	}

	private void OnFlick(Vector3 delta){
		m_UserWave.Velocity += new Vector3 (delta.x, 0, delta.y) * Time.fixedDeltaTime;
		m_UserWave.Position = Vector3.zero;
//		m_UserWave.Position -= new Vector3 (delta.x, 0, delta.y) * Time.fixedDeltaTime;
		m_particle.Play ();
//		m_WaveDirection += new Vector3 (delta.x, 0, delta.y) * Time.fixedDeltaTime;

		m_Finger.SetActive (false);
	}

	public void ResetMove(){
		m_UserWave.ResetWave ();
	}

	public void GoToSea(){
		m_Rigidbody.isKinematic = true;
		Vector3 scale = this.transform.localScale;
		scale.x *= -1;
		this.transform.localScale = scale;
		m_Rigidbody.DOMoveZ (this.transform.position.z + 50, 10);
		ChangeAnimClear ();
	}

	public Animator m_SpriteAnimator;
	private void ChangeAnimClear(){
		m_SpriteAnimator.SetTrigger ("Clear");
	}
}