﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
public class SceneControl : MonoBehaviour {
	public static SceneControl I;

	public string StartSceneName;
	private string MainSceneName;
	private string SubSceneName;

	void Awake(){
		I = this;
	}
	IEnumerator Start(){
		AsyncOperation ao = SceneManager.LoadSceneAsync (StartSceneName, LoadSceneMode.Additive);
		MainSceneName = StartSceneName;
		yield return new WaitUntil (() => ao.isDone);
	}


	public CanvasGroup FadeImage;

	public void LoadScene(string mainScene, string subScene = ""){
		StartCoroutine (IELoadScene(mainScene, subScene));
	}
	private IEnumerator IELoadScene(string mainScene, string subScene)
	{
		FadeImage.blocksRaycasts = true;

		float goal = Time.time + 1.0f;
		float delta;
		Color col = Color.white;
		col.a = 0;
		while (goal > Time.time) {
			delta = goal - Time.time;
			FadeImage.alpha = 1 - delta;
//			FadeImage.color = col;
			yield return null;
		}
		AsyncOperation ao;
		if (!string.IsNullOrEmpty (MainSceneName)) {
			ao = SceneManager.UnloadSceneAsync (MainSceneName);
			yield return new WaitUntil (() => ao.isDone);
		}
		if (!string.IsNullOrEmpty (SubSceneName)) {
			ao = SceneManager.UnloadSceneAsync (SubSceneName);
			yield return new WaitUntil (() => ao.isDone);
		}
		MainSceneName = mainScene;
		SubSceneName = subScene;
		if (!string.IsNullOrEmpty (MainSceneName)) {
			ao = SceneManager.LoadSceneAsync (MainSceneName, LoadSceneMode.Additive);
			yield return new WaitUntil (() => ao.isDone);
		}
		if (!string.IsNullOrEmpty (SubSceneName)) {
			ao = SceneManager.LoadSceneAsync (SubSceneName, LoadSceneMode.Additive);
			yield return new WaitUntil (() => ao.isDone);
		}
		goal = Time.time + 1.0f;
		while (goal > Time.time) {
			delta = goal - Time.time;
			FadeImage.alpha = delta;
//			FadeImage.color = col;
			yield return null;
		}
		FadeImage.alpha = 0;
		FadeImage.blocksRaycasts = false;
//		FadeImage.color = col;

	}

	private int currentStage = -1;
	public void GoNextStage(){
		currentStage++;
		if (currentStage >= 0 && currentStage < stages.Length) {
			LoadScene("GameMain",stages[currentStage]);
		} else {
			currentStage = -1;
			LoadScene ("GameOver");
		}
	}
	public WaveScript[] waves;

	public void ResetWave(){
		foreach (WaveScript wave in waves) {
			wave.ResetWave ();
		}
	}

	public static readonly string[] stages = new string[]{
		"Stage1",
		"Stage2",
        "Stage3",
        "Stage4",
        "Stage5",
    };
}
