﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveScript : MonoBehaviour {
	[Range(0.1f,2.0f)]
	public float K = 1.0f;
	public Vector3 Position;
	public Vector3 Velocity;
	public Vector3 Accel;

	private const float VEL_MAX = 15;
	private Material m_Mat;
	void Start(){
		m_Mat = GetComponent<Renderer> ().material;
	}

	void FixedUpdate(){
		Accel =  - Position * K * Time.fixedTime;
		Velocity += Accel * K * Time.deltaTime;
		Velocity = Vector3.ClampMagnitude (Velocity, VEL_MAX);
		Position += Velocity * K * Time.deltaTime;

		m_Mat.mainTextureOffset = Vector2.Lerp(m_Mat.mainTextureOffset, new Vector2(-Position.x / 50, - Position.z /50),0.1f);
	}
	public void ResetWave(){
		Velocity = new Vector3 (0, 0, 0);
		Accel = new Vector3 (0, 0, 0);
		Position = new Vector3 (0, 0, 0);
	}
}
